#ifndef __AMSMATHUTIL25_RANDOM_HPP__
#define __AMSMATHUTIL25_RANDOM_HPP__

namespace ams
{
namespace rand
{

typedef ::int32_t amsmu_randt1;
typedef ::int64_t amsmu_randt2;

static const amsmu_randt1 dpr32_mod = ( ((amsmu_randt1)1) << ((amsmu_randt1)30) ) - (amsmu_randt1)1;
static const amsmu_randt1 dpr32_mult1 = ( (amsmu_randt1) 1201633 );
static const amsmu_randt1 dpr32_add1 = ( (amsmu_randt1) 293482 );

static const amsmu_randt2 dpr64_mod = ( ((amsmu_randt2)1) << ((amsmu_randt2)62) ) - (amsmu_randt2)1;
static const amsmu_randt2 dpr64_mult1 = ( (amsmu_randt2) 1201633L );
static const amsmu_randt2 dpr64_add1 = ( (amsmu_randt2) 293482L );

extern amsmu_randt1 dpr32_rseed;
extern amsmu_randt2 dpr64_rseed;

amsmu_randt1 dpr32_nextseed(amsmu_randt1 seed);
amsmu_randt2 dpr64_nextseed(amsmu_randt2 seed);



}; //end namespace rand
}; //end namespace ams

#endif

