#include <amsmathutil25/amsmathutil25.hpp>

namespace ams
{
namespace amsmathutil25
{

void test_amsarray1()
{
    amsarray<float> a,b,c,q;
    int64_t I;

    printf("Tests for amsarray...\n");
    q.resize(10);
    q[0] = 1;
    q[9] = 5;
    for(I=0;I<10;I++)
    {
        printf("q[%ld] = %1.3f\n",I,q[I]);
    }

    q.resize(12);
    a = q;
    a = b = q;
    for(I=0;I<12;I++)
    {
        printf("a[%ld] = %1.3f\n",I,a[I]);
    }

    q.resize(8);
    a = q;
    a = b = q;
    for(I=0;I<8;I++)
    {
        printf("a[%ld] = %1.3f\n",I,a[I]);
    }
    
    a.resize(amsmathutil25_threadpsz + 10);
    a.setall(55);
    printf("a.length=%ld\n",a.length);

    b = a;
    for(I=amsmathutil25_threadpsz;I<b.length;I++)
    {
        printf("b[%ld] = %1.3f\n",I,b[I]);
    }

    return;
}

void test_amsarray2()
{
    amsarray<int64_t> a,b,c;
    amsarray<float> q;
    int64_t I;

    printf("Tests for amsarray...\n");

    a.resize(0);
    b = a;
    a.resize(-10);
    b = a;

    printf("a==b?%d\n",a==b);

    a.resize(10);
    b = a;

    printf("a==b?%d\n",a==b);

    a.resize(10000);
    b = a;

    printf("a==b?%d\n",a==b);

    a.setall(55);
    b = a;

    printf("a==b?%d\n",a==b);

    a[0] = 1;

    printf("a==b?%d\n",a==b);

    q = (amsarray<float>)a;
    for(I=q.length-10;I<q.length;I++)
    {
        printf("q[%ld]=%1.3f\n",I,q[I]);
    }


}




}; //end namespace amsmathutil25
}; //end namespace ams